#version 150

#moj_import <light.glsl>

in vec3 Position;
in vec4 Color;
in vec2 UV0;
in ivec2 UV2;
in vec3 Normal;

uniform sampler2D Sampler0;
uniform sampler2D Sampler2;
uniform float GameTime;


uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform vec3 ChunkOffset;

out float vertexDistance;
out vec4 vertexColor;
out vec2 texCoord0;
out vec4 normal;

void main() {
    vec3 Pos = Position;

    #moj_import <generic.glsl>
    vec4 vertexFlag = textureLod(Sampler0, vec2(UV0.x, UV0.y + 16.0 * onepixel.y),0);
    if(vertexFlag.r == 1.0 && vertexFlag.g == 0.0 && vertexFlag.b == 0.0 && vertexFlag.a > 0.49 && vertexFlag.a < 0.51){
        float animation = GameTime * 4000.0;
        Pos.x += sin(Position.x + ChunkOffset.x + animation) / 32;
        Pos.z += cos(Position.z + ChunkOffset.z + animation) / 32;
    }

    gl_Position = ProjMat * ModelViewMat * vec4(Pos + ChunkOffset, 1.0);

    vertexDistance = length((ModelViewMat * vec4(Pos + ChunkOffset, 1.0)).xyz);
    vertexColor = Color * minecraft_sample_lightmap(Sampler2, UV2);
    texCoord0 = UV0;
    normal = ProjMat * ModelViewMat * vec4(Normal, 0.0);
}